// ===========================================================================
//	CFilterControl.h			1995 Apple Computer, Inc. All rights reserved.
// ===========================================================================

#pragma once

#include <LModelObject.h>
#include "CSliderControl.h"


enum {
	SliderAttr_Enabled			= 0x80000000
};

typedef	Uint32	ESliderAttr;

const long	ae_SetValue			= 10001;
const long	ae_SetMax			= 10002;

enum {
	cSlider						= 'Sldr',
	kAESetValue					= 'sVal',
	kAESetMax					= 'sMax',
	pValue						= 'sVal',
	pMaxValue					= 'sMax',
	pLabel						= 'sLbl'
};

class	CFilterControl : public CSliderControl,
				 		 public LModelObject {
public:
	enum { 
		class_ID = 'Filt'
	};
	LCaption 			*mLabel;
	unsigned short		mLabelChanges;

	static CFilterControl*	CreateFilterControlStream(LStream *inStream);
	
						CFilterControl(LStream *inStream);

	virtual				~CFilterControl();

	virtual void		SendAESetValue(Int32 value, Boolean inExecute = false);
	virtual void		SendAESetMax(Int32 max);

		//  AppleEvent Object Model Support 
											  
	virtual void		GetAEProperty(DescType inProperty,
										const AEDesc &inRequestedType,
										AEDesc& outPropertyDesc) const;
	virtual void		SetAEProperty(DescType inProperty,
										const AEDesc &inValue,
										AEDesc& outAEReply);

	virtual void		HandleAppleEvent(
										const AppleEvent	&inAppleEvent,
										AppleEvent			&outAEReply,
										AEDesc				&outResult,
										Int32				inAENumber);
protected:

	virtual void		SliderAction(short newPos);
	virtual void		TrackSlider(Point origMouseLoc);
};